---
layout: post
title: "Apache Arrow 0.4.1 Release"
date: "2017-06-14 10:00:00 -0400"
author: wesm
categories: [release]
---
<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

The Apache Arrow team is pleased to announce the 0.4.1 release of the
project. This is a bug fix release that addresses a regression with Decimal
types in the Java implementation introduced in 0.4.0 (see
[ARROW-1091][10]). There were a total of [31 resolved JIRAs][1].

See the [Install Page][2] to learn how to get the libraries for your platform.

### Python Wheel Installers for Windows

Max Risuhin contributed fixes to enable binary wheel installers to be generated
for Python 3.5 and 3.6. Thus, 0.4.1 is the first Arrow release for which
PyArrow including bundled [Apache Parquet][8] support that can be installed
with either conda or pip across the 3 major platforms: Linux, macOS, and
Windows. Use one of:

```
pip install pyarrow
conda install pyarrow -c conda-forge
```

### Turbodbc 2.0.0 with Apache Arrow Support

[Turbodbc][12], a fast C++ ODBC interface with Python bindings, released
version 2.0.0 including reading SQL result sets as Arrow record batches. The
team used the PyArrow C++ API introduced in version 0.4.0 to construct
`pyarrow.Table` objects inside the `turbodbc` library. Learn more in their
[documentation][13] and install with one of:

```
pip install turbodbc
conda install turbodbc -c conda-forge
```

[1]: https://issues.apache.org/jira/issues/?jql=project%20%3D%20ARROW%20AND%20status%20in%20(Resolved%2C%20Closed)%20AND%20fixVersion%20%3D%200.4.1
[2]: http://arrow.apache.org/install
[8]: http://parquet.apache.org
[9]: http://arrow.apache.org/docs/python/development.html
[10]: https://issues.apache.org/jira/browse/ARROW-1091
[11]: https://github.com/maxris
[12]: http://turbodbc.readthedocs.io/
[13]: http://turbodbc.readthedocs.io/en/latest/pages/advanced_usage.html#apache-arrow-support