---
layout: default
title: Apache Arrow 0.7.1 Release
permalink: /release/0.7.1.html
---
<!--
{% comment %}
Licensed to the Apache Software Foundation (ASF) under one or more
contributor license agreements.  See the NOTICE file distributed with
this work for additional information regarding copyright ownership.
The ASF licenses this file to you under the Apache License, Version 2.0
(the "License"); you may not use this file except in compliance with
the License.  You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->

# Apache Arrow 0.7.1 (1 October 2017)

This is a minor bug release. It was motivated by [ARROW-1601][3], but see the
complete changelog.

## Download

* [**Source Artifacts**][2]
* [Git tag][1]

## Contributors

```shell
$ git shortlog -sn apache-arrow-0.7.0..apache-arrow-0.7.1
    14  Wes McKinney
     6  Kouhei Sutou
     3  siddharth
     2  Paul Taylor
     2  Uwe L. Korn
     1  Amir Malekpour
     1  Bryan Cutler
     1  Deepak Majeti
     1  Kentaro Hayashi
     1  Korn, Uwe
     1  Li Jin
     1  Rene Sugar
     1  Tom Augspurger
     1  Wataru Shimizu
     1  m-nakamura145
     1  rvernica
```

# Changelog

## New Features and Improvements

* [ARROW-1537](https://issues.apache.org/jira/browse/ARROW-1537) - [C++] Support building with full path install_name on macOS
* [ARROW-1546](https://issues.apache.org/jira/browse/ARROW-1546) - [GLib] Support GLib 2.40 again
* [ARROW-1548](https://issues.apache.org/jira/browse/ARROW-1548) - [GLib] Support build append in builder
* [ARROW-1578](https://issues.apache.org/jira/browse/ARROW-1578) - [C++/Python] Run lint checks in Travis CI to fail for linting issues as early as possible
* [ARROW-1592](https://issues.apache.org/jira/browse/ARROW-1592) - [GLib] Add GArrowUIntArrayBuilder
* [ARROW-1608](https://issues.apache.org/jira/browse/ARROW-1608) - Support Release verification script on macOS
* [ARROW-1612](https://issues.apache.org/jira/browse/ARROW-1612) - [GLib] add how to install for mac os to README
* [ARROW-559](https://issues.apache.org/jira/browse/ARROW-559) - Script to easily verify release in all languages

## Bug Fixes

* [ARROW-1497](https://issues.apache.org/jira/browse/ARROW-1497) - [Java] JsonFileReader doesn't set value count for some vectors
* [ARROW-1500](https://issues.apache.org/jira/browse/ARROW-1500) - [C++] Result of ftruncate ignored in MemoryMappedFile::Create
* [ARROW-1529](https://issues.apache.org/jira/browse/ARROW-1529) - [GLib] Fix failure on macOS on Travis CI
* [ARROW-1536](https://issues.apache.org/jira/browse/ARROW-1536) - [C++] Do not transitively depend on libboost_system
* [ARROW-1542](https://issues.apache.org/jira/browse/ARROW-1542) - [C++] Windows release verification script should not modify conda environment
* [ARROW-1544](https://issues.apache.org/jira/browse/ARROW-1544) - [JS] Export Vector type definitions
* [ARROW-1545](https://issues.apache.org/jira/browse/ARROW-1545) - Int64Builder should not need int64() as arg
* [ARROW-1550](https://issues.apache.org/jira/browse/ARROW-1550) - [Python] Fix flaky test on Windows
* [ARROW-1554](https://issues.apache.org/jira/browse/ARROW-1554) - [Python] Document that pip wheels depend on MSVC14 runtime
* [ARROW-1557](https://issues.apache.org/jira/browse/ARROW-1557) - [PYTHON] pyarrow.Table.from_arrays doesn't validate names length
* [ARROW-1591](https://issues.apache.org/jira/browse/ARROW-1591) - C++: Xcode 9 is not correctly detected
* [ARROW-1595](https://issues.apache.org/jira/browse/ARROW-1595) - [Python] Fix package dependency issues causing build failures
* [ARROW-1601](https://issues.apache.org/jira/browse/ARROW-1601) - [C++] READ_NEXT_BITSET reads one byte past the last byte on last iteration
* [ARROW-1606](https://issues.apache.org/jira/browse/ARROW-1606) - Python: Windows wheels don't include .lib files.
* [ARROW-1610](https://issues.apache.org/jira/browse/ARROW-1610) - C++/Python: Only call python-prefix if the default PYTHON_LIBRARY is not present
* [ARROW-1611](https://issues.apache.org/jira/browse/ARROW-1611) - Crash in BitmapReader when length is zero

[1]: https://github.com/apache/arrow/releases/tag/apache-arrow-0.7.1
[2]: https://www.apache.org/dyn/closer.cgi/arrow/arrow-0.7.1/
[3]: https://issues.apache.org/jira/browse/ARROW-1601